#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <dodhooks>
#define PL_VERSION "1.4"

public Plugin:myinfo = 
{
	name = "DoD:S TDM GunGame Instant Respawn", 
	author = "Andersso", 
	description = "Instantly respawn players after death.", 
	version = PL_VERSION, 
	url = "http://www.dodsplugins.net"
};

new g_iDesiredPlayerClass;

public OnPluginStart()
{
	if ((g_iDesiredPlayerClass = FindSendPropInfo("CDODPlayer", "m_iDesiredPlayerClass")) == -1)
	{
		SetFailState("Fatal Error: Unable to find offset \"m_iDesiredPlayerClass\"!");
	}
	
	CreateConVar("dods_tdm_gungame_instantrespawn", PL_VERSION, "DoD:S TDM GunGame Instant Respawn", FCVAR_PLUGIN | FCVAR_REPLICATED | FCVAR_NOTIFY | FCVAR_DONTRECORD);
	
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("player_changeclass", Event_PlayerChangeClass);
}

public Action:Event_PlayerDeath(Handle:hEvent, const String:szName[], bool:bDontBroadcast)
{
	CreateTimer(1.5, Timer_RespawnPlayer, GetEventInt(hEvent, "userid"), TIMER_FLAG_NO_MAPCHANGE);
}

public Action:Timer_RespawnPlayer(Handle:hTimer, any:iClient)
{
	if ((iClient = GetClientOfUserId(iClient)) != 0)
	{
		RespawnPlayer2(iClient);
	}
}

public Action:Event_PlayerChangeClass(Handle:hEvent, const String:szName[], bool:bDontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	if (!IsPlayerAlive(iClient))
	{
		RespawnPlayer2(iClient);
	}
}


RespawnPlayer2(iClient)
{
	if (GetEntData(iClient, g_iDesiredPlayerClass) != -1)
	{
		RespawnPlayer(iClient, false);
	}
} 